package ch.hslu.swk.g03.logger.common;

import java.rmi.Remote;
import java.rmi.RemoteException;
import java.util.ArrayList;


/**
 * RMI Server Interface
 *
 * @author Felix Rohrer <felix.rohrer@stud.hslu.ch>
 */
public interface ServerRmiInterface extends Remote {
    /**
     * Get All LogMessages
     * @return ArrayList with all LogMessages since start
     */
    public ArrayList<LogMessage> getAllMessages() throws RemoteException;
    
    /**
     * Get newer Messages as the given ID 
     * @param lastID Last Known ID
     * @return ArrayList with all new LogMessages
     */
    public ArrayList<LogMessage> getNewMessages(final int lastID) throws RemoteException;
    
    /**
     * Returns one specific LogMessage
     * @param index Index of the LogMessage
     * @return Requested LogMessage at Position Index
     */
    public LogMessage getMessage(final int index) throws RemoteException;
    
    /**
     * Return the latest Message ID
     * @return the latest Message ID
     * @throws RemoteException
     */
    public int getMessageCount() throws RemoteException;
}
