package ch.hslu.swk.g03.logger;

import static org.junit.Assert.*;

import org.junit.*;

import java.io.IOException;
import java.util.Date;

import ch.hslu.loggerinterface.Loglevel;
import ch.hslu.swk.g03.logger.common.ConverterUtils;
import ch.hslu.swk.g03.logger.common.LogMessage;

public class ConverterUtilsTest {
	

	@Before
	public void setUp() throws Exception
	{
		
	}
	
	@After 
	public void tearDown() throws Exception
	{
		
	}
		
	@Test
	public void serializeDeserializeTest() {
		
		LogMessage message = new LogMessage();
		
		message.setComputer("Computer01");
		message.setLoglevel(Loglevel.ERROR);
		message.setMessage("Hallo Welt");
		message.setSource("MySource");
		message.setTimestamp(new Date());
		
		LogMessage newMessage = null;
		
		// Serialize the object
		try {
			byte[] data = ConverterUtils.serialize(message);
		
			// Deserialize the object
			newMessage = (LogMessage)ConverterUtils.deserialize(data);

		} catch (IOException | ClassNotFoundException e) {
			
			fail(e.getMessage());
		}
		
		assertNotNull(newMessage);
		
		if(newMessage != null) {
			
			assertEquals("Computer01", newMessage.getComputer());
			assertEquals(Loglevel.ERROR, newMessage.getLoglevel());
			assertEquals("Hallo Welt", newMessage.getMessage());
			assertEquals("MySource", newMessage.getSource());
		}
	}
}
