package ch.hslu.loggerinterface;

/**
 * Interface for custom logger instances
 *
 * @author SWK Interface Group FS 2013
 * @version 1.0
 */
public interface Logger {
    /**
     * Sends log messages to a server.
     * Logs a message with defined source and log level.
     *
     * @param level Sets the severity of the log message @see ch.hslu.swk.f1301.loggerinterface.Loglevel
     * @param message Sets the message to log. Maximum of 10000 characters
     */
    void log(Loglevel level, String message) throws LoggerException;
    
    /**
     * sets the setup
     * 
     * @param setup the setup to set
     */
    void setSetup(LoggerSetup setup);
    
    /**
     * gets the setup
     * 
     * @return the setup
     */
    LoggerSetup getSetup();
}
