package ch.hslu.swk.g03.logger.server;

import ch.hslu.corba.loggerinterface.CorbaLogLevel;
import ch.hslu.corba.loggerinterface.CorbaLoggerSetupInterfacePOA;

/**
 * POA Implementation of the corba logger setup interface.
 *
 * @author Felix Rohrer <felix.rohrer@stud.hslu.ch>
 */
public class ConcreteCorbaLoggerSetupInterfacePOA extends CorbaLoggerSetupInterfacePOA {
    /**
     * The messgae source.
     */
    private String messageSource = "Not set";

    /**
     * The corba log level.
     */
    private CorbaLogLevel cll = CorbaLogLevel.OFF;

    /**
     * Set the message source.
     *
     * @param string
     *            The message source.
     */
    @Override
    public void setCorbaLogMessageSource(String string) {
	this.messageSource = string;
    }

    /**
     * Sets the corba log level.
     *
     * @param cll
     *            The corba log level
     */
    @Override
    public void setCorbaLogLevel(CorbaLogLevel newCll) {
	this.cll = newCll;
    }

    /**
     * Returns the message source.
     *
     * @return The message source
     */
    @Override
    public String getCorbaLogMessageSource() {
	return messageSource;
    }

    /**
     * Returns the log level.
     *
     * @return The log level.
     */
    @Override
    public CorbaLogLevel getCorbaLogLevel() {
	return cll;
    }

}
