package ch.hslu.swk.g03.logger.server;

import static org.junit.Assert.*;

import java.io.IOException;

import org.junit.After;
import org.junit.Before;
import org.junit.Test;

import ch.hslu.swk.g03.logger.common.LogMessage;

/**
 * @author Felix Rohrer <felix.rohrer@stud.hslu.ch>
 */
public class LoggerDBTest {

    /**
     * @throws java.lang.Exception
     */
    @Before
    public void setUp() throws Exception {
    }

    /**
     * @throws java.lang.Exception
     */
    @After
    public void tearDown() throws Exception {
    }

    /**
     * Test method for
     * {@link ch.hslu.swk.g03.logger.server.LoggerDB#getInstance()}.
     */
    @Test
    public void testGetInstance() {
	assertNotNull(LoggerDB.getInstance());
    }

    /**
     * Test method for
     * {@link ch.hslu.swk.g03.logger.server.LoggerDB#setLogfileName(java.lang.String)}
     * .
     */
    @Test
    public void testSetLogfileName() {
	LoggerDB.getInstance().setLogfileName("newfile.txt");
	// no possible way to verify
	assertTrue(true);
    }

    /**
     * Test method for
     * {@link ch.hslu.swk.g03.logger.server.LoggerDB#openLogfile()}.
     * 
     * @throws IOException
     */
    @Test
    public void testOpenLogfile() throws IOException {
	LoggerDB.getInstance().setLogfileName("LoggerDBTest.txt");
	assertTrue(LoggerDB.getInstance().openLogfile());
    }

    /**
     * Test method for
     * {@link ch.hslu.swk.g03.logger.server.LoggerDB#closeLogfile()}.
     * 
     * @throws IOException
     */
    @Test
    public void testCloseLogfile() throws IOException {
	LoggerDB.getInstance().setLogfileName("LoggerDBTest.txt");
	assertTrue(LoggerDB.getInstance().openLogfile());
	assertTrue(LoggerDB.getInstance().closeLogfile());
    }

    /**
     * Test method for
     * {@link ch.hslu.swk.g03.logger.server.LoggerDB#addMessage(ch.hslu.swk.g03.logger.common.LogMessage)}
     * .
     */
    @Test
    public void testAddMessage() {
	int oldMsgCount = LoggerDB.getInstance().getMessageCount();
	LoggerDB.getInstance().addMessage(new LogMessage("testAddMessage"));
	assertEquals(oldMsgCount + 1, LoggerDB.getInstance().getMessageCount());
    }
    
    /**
     * Test with SaveToFile method for
     * {@link ch.hslu.swk.g03.logger.server.LoggerDB#addMessage(ch.hslu.swk.g03.logger.common.LogMessage)}
     * .
     * @throws IOException 
     */
    @Test
    public void testAddMessageWithFileSave() throws IOException {
	LoggerDB.getInstance().setLogfileName("LoggerDBTest.txt");
	LoggerDB.getInstance().openLogfile();
	int oldMsgCount = LoggerDB.getInstance().getMessageCount();
	LoggerDB.getInstance().addMessage(new LogMessage("testAddMessage"));
	LoggerDB.getInstance().closeLogfile();
	assertEquals(oldMsgCount + 1, LoggerDB.getInstance().getMessageCount());
    }

    /**
     * Test method for
     * {@link ch.hslu.swk.g03.logger.server.LoggerDB#getAllMessages()}.
     */
    @Test
    public void testGetAllMessages() {
	LoggerDB.getInstance().addMessage(new LogMessage("testGetAllMessages"));
	assertNotNull(LoggerDB.getInstance().getAllMessages());
    }

    /**
     * Test method for
     * {@link ch.hslu.swk.g03.logger.server.LoggerDB#printAllMessages()}.
     */
    @Test
    public void testPrintAllMessages() {
	LoggerDB.getInstance().addMessage(new LogMessage("testPrintAllMessages"));
	LoggerDB.getInstance().printAllMessages();
	// no possible way to verify
	assertTrue(true);
    }

    /**
     * Test method for
     * {@link ch.hslu.swk.g03.logger.server.LoggerDB#getMessage(int)}.
     */
    @Test
    public void testGetMessage() {
	LogMessage myMsg = new LogMessage("testGetMessage");
	LoggerDB.getInstance().addMessage(myMsg);
	assertEquals(myMsg, LoggerDB.getInstance().getMessage(LoggerDB.getInstance().getMessageCount() - 1));
    }

    /**
     * Test method for
     * {@link ch.hslu.swk.g03.logger.server.LoggerDB#getMessageCount()}.
     */
    @Test
    public void testGetMessageCount() {
	assertNotNull(LoggerDB.getInstance().getMessageCount());
    }

}
