package ch.hslu.swk.g03.logger.viewer;

import java.awt.Color;
import java.awt.Component;

import javax.swing.JTable;
import javax.swing.table.DefaultTableCellRenderer;

@SuppressWarnings("serial")
public class CustomCellRenderer extends DefaultTableCellRenderer {

	@Override
	public Component getTableCellRendererComponent(JTable table, Object value,
			boolean isSelected, boolean hasFocus, int row, int column) {

		Component rendererComp = super.getTableCellRendererComponent(table,
				value, isSelected, hasFocus, row, column);

		// Set foreground color
		// rendererComp.setForeground(Color.red);
		// Set background color
		
		String loglevel = (String) table.getModel().getValueAt(row, 2).toString();
		
	    switch (loglevel) {
			case "OFF":
				setBackground(Color.WHITE);
				break;
			case "ERROR":
				setBackground(Color.RED);
				break;
			case "WARNING":
				setBackground(Color.YELLOW);
				break;
			case "INFO":
				setBackground(Color.CYAN);
				break;
			case "DEBUG":
				setBackground(Color.GREEN);
				break;
			default:
				setBackground(Color.WHITE);
				break;
		}
	    
		return rendererComp;
	}
}
