package ch.hslu.swk.g03.logger.viewer;

import java.rmi.Naming;
import java.util.ArrayList;
import java.util.Properties;

import ch.hslu.swk.g03.logger.common.LogMessage;
import ch.hslu.swk.g03.logger.common.ServerRmiInterface;

/**
 * Class for fetching Messages to the GUI in Background.
 */
public final class FetchThread extends Thread {
	private static FetchThread instance;

	/**
	 * Default Constructor.
	 */
	private FetchThread() {
		super("ServerfetchThread");
	}

	/**
	 * Returns new FetchThread - Singleton.
	 * @return FetchThread instance
	 */
	public static FetchThread getInstance() {
		if (FetchThread.instance == null) {
			try {
				FetchThread.instance = new FetchThread();
			} catch (Exception ex) {
				ex.printStackTrace();
			}
		}
		return FetchThread.instance;
	}

	/**
	 * Thread-Start Method.
	 */
	public void run() {
		try {
			int lastID = 0;
			final Properties mySettings = new Properties();
			String RMIServerHost = "localhost";
			String RMIServerPort = "10124";
			String RMIServerName = "G03RMIServer";
			try {
				mySettings.load(FetchThread.class.getClassLoader()
						.getResourceAsStream("viewer.properties"));
				RMIServerHost = mySettings.getProperty("RMIServerHost");
				RMIServerPort = mySettings.getProperty("RMIServerPort");
				RMIServerName = mySettings.getProperty("RMIServerName");
			}catch(Exception ex){
				
			}
			//final Registry registry = LocateRegistry.getRegistry(RMIServerHost, 10124);
			//final ServerRmiInterface server = (ServerRmiInterface) registry.lookup(RMIServerName);
			System.out.println("Connecting to " + "rmi://" + RMIServerHost + ":" + RMIServerPort + "/" + RMIServerName);
			final ServerRmiInterface server = (ServerRmiInterface) Naming.lookup("rmi://" + RMIServerHost + ":" + RMIServerPort + "/" + RMIServerName); 
			while (true) {
				try {
					final ArrayList<LogMessage> messages = server
							.getNewMessages(lastID);
					Loggergui.addMessage(messages);
					lastID += messages.size();
					System.out.println("gui.addMessage now " + lastID);
					Thread.sleep(50);
				} catch (InterruptedException e) {
					e.printStackTrace();
				}
			}
		} catch (Exception ex) {
			ex.printStackTrace();
		}
	}
}
